#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define BUFFER 4096

int main( int argc, char *argv[] ) {
	struct timeval st;
	struct tm *lt;
	time_t wall_clock;
	int lastsec=0,retval,lines=0,sec[60],five_min[300],fifteen_min[900],avg,five_min_avg,fifteen_min_avg,i;
	fd_set ifds,activeset;
	char data[BUFFER];
	int size=BUFFER;

	FD_ZERO( &activeset );
	FD_SET( 0, &activeset );

	for( i=0 ; i<60 ; i++ )  { sec[i] = 0;         }
	for( i=0 ; i<300 ; i++ ) { five_min[i] = 0;    }
	for( i=0 ; i<900 ; i++ ) { fifteen_min[i] = 0; }

	while(1) {
		ifds = activeset;
		st.tv_sec = 0;
		st.tv_usec = 500000;
		retval = select( 1, &ifds, NULL, NULL, &st );
		wall_clock = time( NULL );

		if( retval == -1 ) {
			perror( "Couldn't select()" );
			return( EXIT_FAILURE );
		}
				
		if( FD_ISSET( 0, &ifds ) && fgets( data, size, stdin ) ) {
			if( strlen( data ) > 0 && data[strlen(data)-1] == 0x0a ) {
				lines++;
			}
		}
		if( lastsec == 0 ) {
			lastsec = (int)wall_clock;
		}

		if( (int)wall_clock != lastsec ) {
			sec[lastsec % 60] = lines;
			five_min[lastsec % 300] = lines;
			fifteen_min[lastsec % 900] = lines;
			lines = lines / ( (int)wall_clock-lastsec );

			avg = 0;
			for( i=0 ; i<60 ; i++ ) {
				avg += sec[i];
			}

			five_min_avg = 0;
			for( i=0 ; i<300 ; i++ ) {
				five_min_avg += five_min[i];
			}
		
			fifteen_min_avg = 0;
			for( i=0 ; i<900 ; i++ ) {
				fifteen_min_avg += fifteen_min[i];
			}

			lt = localtime( &wall_clock );

			printf( "%.4d-%.2d-%.2d %.2d:%.2d:%.2d lines per sec/min/5min/15min %d/%.2f/%.2f/%.2f\n",
				lt->tm_year + 1900,
				lt->tm_mon + 1,
				lt->tm_mday,
				lt->tm_hour,
				lt->tm_min,
				lt->tm_sec,
				lines,
				(double)avg/60,
				(double)five_min_avg/300,
				(double)fifteen_min_avg/900 );

			lines=0;
			lastsec = (int)wall_clock;
			sec[lastsec % 60] = 0;
		}
	}
	return( EXIT_SUCCESS );
}
